Direct3D 11 Interoperability(3)

NAME
Direct3D 11 Interoperability -

  Enumerations

enum cudaD3D11DeviceList { cudaD3D11DeviceListAll = 1, cudaD3D11DeviceListCurrentFrame = 2, cudaD3D11DeviceListNextFrame = 3 }

  Functions

cudaError_t cudaD3D11GetDevice (int *device, IDXGIAdapter *pAdapter)
Gets the device number for an adapter.
cudaError_t cudaD3D11GetDevices (unsigned int *pCudaDeviceCount, int *pCudaDevices, unsigned int cudaDeviceCount, ID3D11Device *pD3D11Device, enum cudaD3D11DeviceList deviceList)
Gets the CUDA devices corresponding to a Direct3D 11 device.
cudaError_t cudaGraphicsD3D11RegisterResource (struct cudaGraphicsResource **resource, ID3D11Resource *pD3DResource, unsigned int flags)
Register a Direct3D 11 resource for access by CUDA.

Detailed Description

This section describes the Direct3D 11 interoperability functions of the CUDA runtime application programming interface. Note that mapping of Direct3D 11 resources is performed with the graphics API agnostic, resource mapping interface described in Graphics Interopability.

Enumeration Type Documentation

  enum cudaD3D11DeviceList

CUDA devices corresponding to a D3D11 device

Enumerator:

cudaD3D11DeviceListAll
    The CUDA devices for all GPUs used by a D3D11 device

cudaD3D11DeviceListCurrentFrame
    The CUDA devices for the GPUs used by a D3D11 device in its currently rendering frame

cudaD3D11DeviceListNextFrame
    The CUDA devices for the GPUs to be used by a D3D11 device in the next frame

Function Documentation

  cudaError_t cudaD3D11GetDevice (int * device, IDXGIAdapter * pAdapter)

Returns in *device the CUDA-compatible device corresponding to the adapter pAdapter obtained from IDXGIFactory::EnumAdapters. This call will succeed only if a device on adapter pAdapter is CUDA-compatible.

Parameters:
    device - Returns the device corresponding to pAdapter
    pAdapter - D3D11 adapter to get device for

Returns:
    cudaSuccess, cudaErrorInvalidValue, cudaErrorUnknown

Note:
    Note that this function may also return error codes from previous, asynchronous launches.

See also:
    cudaGraphicsUnregisterResource, cudaGraphicsMapResources, cudaGraphicsSubResourceGetMappedArray, cudaGraphicsResourceGetMappedPointer, cuD3D11GetDevice

  cudaError_t cudaD3D11GetDevices (unsigned int * pCudaDeviceCount, int * pCudaDevices, unsigned int cudaDeviceCount, ID3D11Device * pD3D11Device, enum cudaD3D11DeviceList deviceList)

Returns in *pCudaDeviceCount the number of CUDA-compatible devices corresponding to the Direct3D 11 device pD3D11Device. Also returns in *pCudaDevices at most cudaDeviceCount of the the CUDA-compatible devices corresponding to the Direct3D 11 device pD3D11Device.

If any of the GPUs being used to render pDevice are not CUDA capable then the call will return cudaErrorNoDevice.

Parameters:
    pCudaDeviceCount - Returned number of CUDA devices corresponding to pD3D11Device
    pCudaDevices - Returned CUDA devices corresponding to pD3D11Device
    cudaDeviceCount - The size of the output device array pCudaDevices
    pD3D11Device - Direct3D 11 device to query for CUDA devices
    deviceList - The set of devices to return. This set may be cudaD3D11DeviceListAll for all devices, cudaD3D11DeviceListCurrentFrame for the devices used to render the current frame (in SLI), or cudaD3D11DeviceListNextFrame for the devices used to render the next frame (in SLI).

Returns:
    cudaSuccess, cudaErrorNoDevice, cudaErrorUnknown

Note:
    Note that this function may also return error codes from previous, asynchronous launches.

See also:
    cudaGraphicsUnregisterResource, cudaGraphicsMapResources, cudaGraphicsSubResourceGetMappedArray, cudaGraphicsResourceGetMappedPointer, cuD3D11GetDevices

  cudaError_t cudaGraphicsD3D11RegisterResource (struct cudaGraphicsResource ** resource, ID3D11Resource * pD3DResource, unsigned int flags)

Registers the Direct3D 11 resource pD3DResource for access by CUDA.

If this call is successful, then the application will be able to map and unmap this resource until it is unregistered through cudaGraphicsUnregisterResource(). Also on success, this call will increase the internal reference count on pD3DResource. This reference count will be decremented when this resource is unregistered through cudaGraphicsUnregisterResource().

This call potentially has a high-overhead and should not be called every frame in interactive applications.

The type of pD3DResource must be one of the following.

•   ID3D11Buffer: may be accessed via a device pointer

•   ID3D11Texture1D: individual subresources of the texture may be accessed via arrays

•   ID3D11Texture2D: individual subresources of the texture may be accessed via arrays

•   ID3D11Texture3D: individual subresources of the texture may be accessed via arrays

The flags argument may be used to specify additional parameters at register time. The valid values for this parameter are

•   cudaGraphicsRegisterFlagsNone: Specifies no hints about how this resource will be used.

•   cudaGraphicsRegisterFlagsSurfaceLoadStore: Specifies that CUDA will bind this resource to a surface reference.

•   cudaGraphicsRegisterFlagsTextureGather: Specifies that CUDA will perform texture gather operations on this resource.

Not all Direct3D resources of the above types may be used for interoperability with CUDA. The following are some limitations.

•   The primary rendertarget may not be registered with CUDA.

•   Textures which are not of a format which is 1, 2, or 4 channels of 8, 16, or 32-bit integer or floating-point data cannot be shared.

•   Surfaces of depth or stencil formats cannot be shared.

A complete list of supported DXGI formats is as follows. For compactness the notation A_{B,C,D} represents A_B, A_C, and A_D.

•   DXGI_FORMAT_A8_UNORM

•   DXGI_FORMAT_B8G8R8A8_UNORM

•   DXGI_FORMAT_B8G8R8X8_UNORM

•   DXGI_FORMAT_R16_FLOAT

•   DXGI_FORMAT_R16G16B16A16_{FLOAT,SINT,SNORM,UINT,UNORM}

•   DXGI_FORMAT_R16G16_{FLOAT,SINT,SNORM,UINT,UNORM}

•   DXGI_FORMAT_R16_{SINT,SNORM,UINT,UNORM}

•   DXGI_FORMAT_R32_FLOAT

•   DXGI_FORMAT_R32G32B32A32_{FLOAT,SINT,UINT}

•   DXGI_FORMAT_R32G32_{FLOAT,SINT,UINT}

•   DXGI_FORMAT_R32_{SINT,UINT}

•   DXGI_FORMAT_R8G8B8A8_{SINT,SNORM,UINT,UNORM,UNORM_SRGB}

•   DXGI_FORMAT_R8G8_{SINT,SNORM,UINT,UNORM}

•   DXGI_FORMAT_R8_{SINT,SNORM,UINT,UNORM}

If pD3DResource is of incorrect type or is already registered, then cudaErrorInvalidResourceHandle is returned. If pD3DResource cannot be registered, then cudaErrorUnknown is returned.

Parameters:
    resource - Pointer to returned resource handle
    pD3DResource - Direct3D resource to register
    flags - Parameters for resource registration

Returns:
    cudaSuccess, cudaErrorInvalidDevice, cudaErrorInvalidValue, cudaErrorInvalidResourceHandle, cudaErrorUnknown

Note:
    Note that this function may also return error codes from previous, asynchronous launches.

See also:
    cudaGraphicsUnregisterResource, cudaGraphicsMapResources, cudaGraphicsSubResourceGetMappedArray, cudaGraphicsResourceGetMappedPointer, cuGraphicsD3D11RegisterResource

Author

Generated automatically by Doxygen from the source code.